=== fileattrs/CMakeLists.txt ===
install(FILES
	debuginfo.attr desktop.attr elf.attr font.attr metainfo.attr
	pkgconfig.attr ocaml.attr
	rpm_macro.attr rpm_lua.attr script.attr sysusers.attr usergroup.attr
	DESTINATION ${RPM_CONFIGDIR}/fileattrs
)
