=== debian/changelog ===
rpm (6.0.0-2) unstable; urgency=medium

  * macros: do not verify signatures by default

 -- Luca Boccassi <bluca@debian.org>  Fri, 07 Nov 2025 00:56:15 +0000

rpm (6.0.0-1) unstable; urgency=medium

  * Drop +dfsg repacking, html docs were removed
  * d/watch: update to version 5
  * New upstream version 6.0.0
  * Drop usermod-root.patch, merged upstream
  * Make rpm-sequoia a requirement
  * Drop patches that modify RPM macros
  * d/control: bump Standards-Version to 4.7.2, no changes
  * Bump dependency on rpm-sequoia
  * Add build dependency on scdoc
  * Backport patch to fix build failure
  * Drop rpm-i18n package, locale files no longer built
  * Install new files
  * Update symbols files for 6.0.0
  * Update d/copyright for removed/renamed files
  * Update Lintian overrides for groff
  * Ignore mangled C++ symbols
  * Update Lintian overrides for test files
  * autopkgtest: avoid test failure and don't verify signature

 -- Luca Boccassi <bluca@debian.org>  Thu, 06 Nov 2025 00:56:55 +0000
