=== debian/watch ===
Version: 5
Template: Github
Owner: rpm-software-management
Project: rpm
Uversion-Mangle: s/(\d)[_\.\-\+]?((?:RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/; s/-release//
