=== debian/changelog ===
rpm (6.0.1-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 22 Jan 2026 21:55:32 +0000

rpm (6.0.1-1) unstable; urgency=medium

  * New upstream version 6.0.1
  * Drop luaopen-posix-fix.patch, merged upstream
  * Update symbols files for 6.0.1

 -- Luca Boccassi <bluca@debian.org>  Mon, 15 Dec 2025 16:48:39 +0000
