## rpm howto

=== Makefile ===
# This Makefile was automatically created by autotexmake.
# It's used for compiling rpm_howto.tex.
#
MAIN_FILE = rpm_howto.tex
TEX_INCLUDES = rpm_howto.tex 
PS_DPI = 600
L2HOPTS=-dir html/ -split 4 -html_version 3.2,table -short_index

AUX_FILE=$(MAIN_FILE:.tex=.aux)
DVI_FILE=$(MAIN_FILE:.tex=.dvi)
PS_FILE=$(MAIN_FILE:.tex=.ps)

# first target in Makefile is default target
.PHONY:	default
default:	target

html:	dvi psonepass
	latex2html $(L2HOPTS) $(MAIN_FILE)
 
html_fast:	aux
	latex2html $(L2HOPTS) $(MAIN_FILE)
                                                                                
# subdirectories to take into consideration
.PHONY:	SUBDIRS
SUBDIRS:	

.PHONY: auxforce
auxforce:	SUBDIRS
	latex $(MAIN_FILE) || rm $(AUX_FILE)

.PHONY:	aux
aux:	$(AUX_FILE)

$(AUX_FILE): SUBDIRS  $(MAIN_FILE) $(TEX_INCLUDES)
	latex $(MAIN_FILE)

.PHONY:	dviforce
dviforce:	auxforce
	latex $(MAIN_FILE)

.PHONY:	dvithreepass
dvithreepass:	dviforce
	latex $(MAIN_FILE)

.PHONY:	dvi
dvi:	aux $(DVI_FILE)

$(DVI_FILE):	aux $(MAIN_FILE) $(TEX_INCLUDES)
	latex $(MAIN_FILE)

.PHONY:	psonepass
psonepass:	aux
	rm -f $(PS_FILE).tmp
	dvips -D $(PS_DPI) -t a4 $(DVI_FILE) -o $(PS_FILE).tmp
	mv $(PS_FILE).tmp $(PS_FILE)

.PHONY:	pstwopass
pstwopass:	auxforce dviforce ps

.PHONY:	psthreepass
psthreepass:	dviforce ps

.PHONY:	ps
ps:	$(PS_FILE)

$(PS_FILE):	$(DVI_FILE)
	# I use a temp file to make using gv and co in "watch file" mode
	# less painless.
	rm -f $(PS_FILE).tmp
	dvips -D $(PS_DPI) -t a4 $(DVI_FILE) -o $(PS_FILE).tmp
	mv $(PS_FILE).tmp $(PS_FILE)

# specify default target:
target:	psthreepass

# every Makefile should contain a clean target:
.PHONY:	clean
clean:
	@rm -f $(MAIN_FILE:.tex=.log) $(AUX_FILE) $(PS_FILE).tmp
